//+------------------------------------------------------------------+
//|                                                      ViTrade.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "BoraBo"
#property link      ""

extern int     corner            = 1; //      
extern string  markObject        = "ViTrade"; //      
extern int     dist_X_TradeZone  = 100; //             

int      NumberOfTry    = 5; //   
int      Slippage       = 33; //  
bool     UseSound       = true; //   
string   NameFileSound  = "expert.wav"; //   


color clOpenBuy   = CLR_NONE;
color clOpenSell  = CLR_NONE;
color clCloseBuy  = CLR_NONE;
color clCloseSell = CLR_NONE;

#include <stdlib.mqh>

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+

int init() {
   //----
   start();
   //----
   return (0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+

int deinit() {
   //----
   DelObj(markObject);
   //----
   return (0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+

int start() {
   //----
   string sLabelName;
   while (IsExpertEnabled()) {
      GetLastError(); //   
      //   
      CreateLable(StringConcatenate("dist_X", markObject), corner, dist_X_TradeZone + 1, 15, "|", 50, "Arial", Green);


      sLabelName = StringConcatenate("Close ", markObject);
      if (ObjectGet(sLabelName, OBJPROP_XDISTANCE)>(dist_X_TradeZone + 1)) {
         ClosePositions(Symbol());
      }
      CreateLable(sLabelName, corner, 20, 30, "Close All", 14, "Arial", Red);
      WindowRedraw();
      Sleep(1000);
   }
   //----
   return (0);
}
//+------------------------------------------------------------------+

// ================= CreateLable =================================

bool CreateLable(string sLabelName, int iCorner, int iX, int iY, string sText, int iFontsize, string sFontname, color cTextColor) {
   bool res = true;
   if(ObjectFind(sLabelName) != 0) res = ObjectCreate(sLabelName, OBJ_LABEL, 0, 0, 0);
   res = (res && ObjectSet(sLabelName, OBJPROP_CORNER, iCorner));
   res = (res && ObjectSetText(sLabelName, sText, iFontsize, sFontname, cTextColor));
   res = (res && ObjectSet(sLabelName, OBJPROP_XDISTANCE, iX));
   res = (res && ObjectSet(sLabelName, OBJPROP_YDISTANCE, iY));
   return (res);
}

// ==============  DelObj ===================

void DelObj(string txtPart) {
   string lbl;
   for (int i = ObjectsTotal() - 1; i >= 0; i--) {
      lbl = ObjectName(i);
      if (StringFind(lbl, txtPart, 0)>-1) ObjectDelete(lbl);
   }
   return;
}


//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 19.02.2008                                                     |
//|   :                                   |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                  |
//|    mn - MagicNumber                (-1   -  )                    |
//+----------------------------------------------------------------------------+

void ClosePositions(string sy = "", int op = -1, int mn = -1) {
   int i, k = OrdersTotal();

   if (sy == "0") sy = Symbol();
   for (i = k - 1; i >= 0; i--) {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
         if ((OrderSymbol() == sy || sy == "") && (op < 0 || OrderType() == op)) {
            if (OrderType() == OP_BUY || OrderType() == OP_SELL) {
               if (mn < 0 || OrderMagicNumber() == mn) ClosePosBySelect();
            }
         }
      }
   }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|    : 19.02.2008                                                      |
//|  :                      |
//+----------------------------------------------------------------------------+

void ClosePosBySelect() {
   bool fc;
   color clClose;
   double ll, pa, pb, pp;
   int err, it;

   if (OrderType() == OP_BUY || OrderType() == OP_SELL) {
      for (it = 1; it <= NumberOfTry; it++) {
         if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
         while (!IsTradeAllowed()) Sleep(5000);
         RefreshRates();
         pa = MarketInfo(OrderSymbol(), MODE_ASK);
         pb = MarketInfo(OrderSymbol(), MODE_BID);
         if (OrderType() == OP_BUY) {
            pp = pb;
            clClose = clCloseBuy;
         } else {
            pp = pa;
            clClose = clCloseSell;
         }
         ll = OrderLots();
         fc = OrderClose(OrderTicket(), ll, pp, Slippage, clClose);
         if (fc) {
            if (UseSound) PlaySound(NameFileSound);
            break;
         } else {
            err = GetLastError();
            if (err == 146) while (IsTradeContextBusy()) Sleep(1000 * 11);
            Print("Error(", err, ") Close ", GetNameOP(OrderType()), " ",
                    ErrorDescription(err), ", try ", it);
            Print(OrderTicket(), "  Ask=", pa, "  Bid=", pb, "  pp=", pp);
            Print("sy=", OrderSymbol(), "  ll=", ll, "  sl=", OrderStopLoss(),
                    "  tp=", OrderTakeProfit(), "  mn=", OrderMagicNumber());
            Sleep(1000 * 5);
         }
      }
   } else Print("  . Close ", GetNameOP(OrderType()));
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                          |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    op -                                       |
//+----------------------------------------------------------------------------+

string GetNameOP(int op) {
   switch (op) {
      case OP_BUY: return ("Buy");
      case OP_SELL: return ("Sell");
      case OP_BUYLIMIT: return ("Buy Limit");
      case OP_SELLLIMIT: return ("Sell Limit");
      case OP_BUYSTOP: return ("Buy Stop");
      case OP_SELLSTOP: return ("Sell Stop");
      default: return ("Unknown Operation");
   }
}

